/*
 * Copyright (c) 2001 Will Day <willday@hpgx.net>
 *
 *    This file is part of Metamod.
 *
 *    Metamod is free software; you can redistribute it and/or modify it
 *    under the terms of the GNU General Public License as published by the
 *    Free Software Foundation; either version 2 of the License, or (at
 *    your option) any later version.
 *
 *    Metamod is distributed in the hope that it will be useful, but
 *    WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with Metamod; if not, write to the Free Software Foundation,
 *    Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *    In addition, as a special exception, the author gives permission to
 *    link the code of this program with the Half-Life Game Engine ("HL
 *    Engine") and Modified Game Libraries ("MODs") developed by Valve,
 *    L.L.C ("Valve").  You must obey the GNU General Public License in all
 *    respects for all of the code used other than the HL Engine and MODs
 *    from Valve.  If you modify this file, you may extend this exception
 *    to your version of the file, but you are not obligated to do so.  If
 *    you do not wish to do so, delete this exception statement from your
 *    version.
 *
 */

// this file has the commands in it, as we use an adminmod frontent
// we can transfer data with the plugin useing server console commands.

#include "chickenmod.h"
#include "servconsole.h"
#include "version.h"

void serv_unchicken(void);
void serv_chicken(void);

void MyGameDLLInit( void ) {
  REG_SVR_COMMAND("serv_unchicken", serv_unchicken);
  REG_SVR_COMMAND("serv_chicken", serv_chicken);

  PRINT_SERVER_CONSOLE("ChickenMod is loaded.");
}

void serv_unchicken( void ) {
	const char *cmd;
	cmd=CMD_ARGV(1);

	CBaseEntity *pEntity;
	pEntity = UTIL_PlayerByIndex(atoi(cmd));

	if(!pEntity) return;
	if(!pEntity->edict()->v.euser2 || pEntity->edict()->v.euser2 == 0) return;

	pEntity->edict()->v.euser2->v.flags |= FL_KILLME;
	pEntity->edict()->v.euser2 = 0;
	pEntity->edict()->v.renderamt = 255;
	pEntity->edict()->v.rendermode = kRenderNormal;

	if(pEntity->edict()->v.health > 100) {
		pEntity->edict()->v.health = 100;
	}

	CLIENT_COMMAND(pEntity->edict(), "setinfo cl_lw 1;");
}

void serv_chicken( void ) {
	const char *cmd;
	cmd=CMD_ARGV(1);

	CBaseEntity *pEntity;
	pEntity = UTIL_PlayerByIndex(atoi(cmd));

	if(!pEntity) return;
	if(pEntity->edict()->v.euser2 && pEntity->edict()->v.euser2 != 0) return;

	edict_t *pSpawnEnt;
	pSpawnEnt = CREATE_NAMED_ENTITY(MAKE_STRING("info_target"));
	pSpawnEnt->v.classname = MAKE_STRING("chicken_model");
	pSpawnEnt->v.owner = pEntity->edict();
	pSpawnEnt->v.origin.x = pEntity->edict()->v.origin.x;
	pSpawnEnt->v.origin.y = pEntity->edict()->v.origin.y;
	pSpawnEnt->v.origin.z = pEntity->edict()->v.origin.z;
	pSpawnEnt->v.angles.x = 0;
	pSpawnEnt->v.angles.y = pEntity->edict()->v.angles.y;
	pSpawnEnt->v.angles.z = 0;
	pSpawnEnt->v.takedamage = DAMAGE_NO;
	pSpawnEnt->v.solid = SOLID_NOT;
	pSpawnEnt->v.movetype = MOVETYPE_FLY;
	SET_MODEL(pSpawnEnt, "models/chick.mdl");
	pSpawnEnt->v.rendermode = kRenderNormal;
	pSpawnEnt->v.renderfx = kRenderFxNone;
	pSpawnEnt->v.renderamt = 128;
	DispatchSpawn( pSpawnEnt );
	pEntity->edict()->v.euser2 = pSpawnEnt;

	pEntity->edict()->v.renderamt = 0;
	pEntity->edict()->v.rendermode = kRenderTransAdd;
	pEntity->edict()->v.health = 250;

	CLIENT_COMMAND(pEntity->edict(), "setinfo cl_lw 0;");
}