/*
 * Copyright (c) 2001 Will Day <willday@hpgx.net>
 *
 *    This file is part of Metamod.
 *
 *    Metamod is free software; you can redistribute it and/or modify it
 *    under the terms of the GNU General Public License as published by the
 *    Free Software Foundation; either version 2 of the License, or (at
 *    your option) any later version.
 *
 *    Metamod is distributed in the hope that it will be useful, but
 *    WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with Metamod; if not, write to the Free Software Foundation,
 *    Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *    In addition, as a special exception, the author gives permission to
 *    link the code of this program with the Half-Life Game Engine ("HL
 *    Engine") and Modified Game Libraries ("MODs") developed by Valve,
 *    L.L.C ("Valve").  You must obey the GNU General Public License in all
 *    respects for all of the code used other than the HL Engine and MODs
 *    from Valve.  If you modify this file, you may extend this exception
 *    to your version of the file, but you are not obligated to do so.  If
 *    you do not wish to do so, delete this exception statement from your
 *    version.
 *
 */

#include "chickenmod.h"

// used to find what player we are doing things to
CBaseEntity	*UTIL_PlayerByIndex( int playerIndex ) {
  CBaseEntity *pPlayer = NULL;
  if ( playerIndex > 0 && playerIndex <= gpGlobals->maxClients ) {
    edict_t *pPlayerEdict = INDEXENT( playerIndex );
    if ( pPlayerEdict && !pPlayerEdict->free ) {
      pPlayer = CBaseEntity::Instance( pPlayerEdict );
		}
  }
  return pPlayer;
}

// for some reason, it asks for this, so we give it to them.
edict_t *DBG_EntOfVars( const entvars_t *pev ) {
   if (pev->pContainingEntity != NULL) return pev->pContainingEntity;
   edict_t* pent = (*g_engfuncs.pfnFindEntityByVars)((entvars_t*)pev);
   if (pent == NULL) ((entvars_t *)pev)->pContainingEntity = pent;
   return pent;
}